#ifndef _CONSTANTS_H_
#define _CONSTANTS_H_

const int ACKDATA_LENGTH = 480; //bits
const int ACKFRAME_SIZE = 800;   //bits: That is 100 Bytes.
                               
const int HEADER_LENGTH = 320; //Average header length in bits
                               //that is 40 Bytes.

static double offset = 0.000001;   //current time is changed by
                                  //this value to use different event
                                  //times for successive data frames, ACK 
                                  //and NACK frames.
                                     
enum SourceType {Node, Buffer, Link};
enum Frame_Type {Data, ACK, Both, NACK}; /* ``Both'' used only if data 
					   traffic is bidirectional.  */
enum Node_State {Normal, Recovery};

enum Frame_Status {OK, damaged};

static double prevdata_linktime = 0; //used for generating event 
                                     //time for the event:data frame given
                                     //from buffer to link

static double acklinktime = 0;       //used for generating event time for
				      //an ack or nack frame event: frame
                                     //given from buffer to link

#endif
