#ifndef _FRAME_H_
#define _FRAME_H_
/* The header file contains the class definitions for the frame class.
*/

#include "link.h"
#include "constants.h"

class frame  /* a frame or packet */
{
public:
Frame_Status status;  /*status of frame: OK/damaged */
Frame_Type type;      /*type of frame: Data/ACK/NACK */  
int dlength ;         /*size of data in the frame */
int hlength ;         /*size of header in the frame*/
int tlength ; /* Total length of the frame: total length=dlength + 
		 hlength */
int dataseq ; /* sequence number of the frame itself */
int ackseq  ; /* sequence number of the frame it acknowledges */

public:

void settype(Frame_Type val){type = val;}
//sets the type of frame to val

void setstatus(Frame_Status val){status = val;}
//sets the status of frame to val

void setdlength(int dlen){dlength = dlen;}
//sets the data length of frame(dlength) to dlen

void sethlength(int hlen){hlength = hlen;}
//sets header lenth of frame(hlength) to hlen)

void settlength(int tlen){tlength = tlen;}
//sets total length of frame(tlength) to tlen

void setdataseq(int seqno){dataseq = seqno;}
/*sets sequence number of the data frame(dataseq) to seqno
At source: it is the sequence number of the frame the source is sending
At destination: it is 0 for a NAcK and an ACK frame
*/

void setackseq(int seqno){ackseq = seqno;}
/*sets the ackseq value of the frame
At source node: it is zero
At destination node:
For an ACK frame: it is the sequence number of the frame the
destination is acknowledging
For a NACK frame: it is the sequence number of the frame
the destination was expecting when a frame arrived out-of-sequence or the
sequence number of the frame that arrived damaged
*/

};

#endif
